pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (zlib_adamain, Spec_File_Name => "b__zlib_ada.ads");
pragma Source_File_Name (zlib_adamain, Body_File_Name => "b__zlib_ada.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body zlib_adamain is

   E074 : Short_Integer; pragma Import (Ada, E074, "system__os_lib_E");
   E021 : Short_Integer; pragma Import (Ada, E021, "ada__exceptions_E");
   E017 : Short_Integer; pragma Import (Ada, E017, "system__soft_links_E");
   E015 : Short_Integer; pragma Import (Ada, E015, "system__exception_table_E");
   E040 : Short_Integer; pragma Import (Ada, E040, "ada__containers_E");
   E069 : Short_Integer; pragma Import (Ada, E069, "ada__io_exceptions_E");
   E030 : Short_Integer; pragma Import (Ada, E030, "ada__numerics_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "ada__strings_E");
   E058 : Short_Integer; pragma Import (Ada, E058, "ada__strings__maps_E");
   E061 : Short_Integer; pragma Import (Ada, E061, "ada__strings__maps__constants_E");
   E045 : Short_Integer; pragma Import (Ada, E045, "interfaces__c_E");
   E024 : Short_Integer; pragma Import (Ada, E024, "system__exceptions_E");
   E085 : Short_Integer; pragma Import (Ada, E085, "system__object_reader_E");
   E052 : Short_Integer; pragma Import (Ada, E052, "system__dwarf_lines_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "system__soft_links__initialize_E");
   E039 : Short_Integer; pragma Import (Ada, E039, "system__traceback__symbolic_E");
   E108 : Short_Integer; pragma Import (Ada, E108, "ada__strings__utf_encoding_E");
   E116 : Short_Integer; pragma Import (Ada, E116, "ada__tags_E");
   E011 : Short_Integer; pragma Import (Ada, E011, "ada__strings__text_buffers_E");
   E139 : Short_Integer; pragma Import (Ada, E139, "interfaces__c__strings_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "ada__streams_E");
   E131 : Short_Integer; pragma Import (Ada, E131, "system__finalization_root_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "ada__finalization_E");
   E133 : Short_Integer; pragma Import (Ada, E133, "system__storage_pools_E");
   E122 : Short_Integer; pragma Import (Ada, E122, "system__finalization_masters_E");
   E135 : Short_Integer; pragma Import (Ada, E135, "system__pool_global_E");
   E006 : Short_Integer; pragma Import (Ada, E006, "zlib_E");
   E004 : Short_Integer; pragma Import (Ada, E004, "zlib__thin_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "zlib__streams_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E002 := E002 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "zlib__streams__finalize_spec");
      begin
         if E002 = 0 then
            F1;
         end if;
      end;
      E006 := E006 - 1;
      declare
         procedure F2;
         pragma Import (Ada, F2, "zlib__finalize_spec");
      begin
         if E006 = 0 then
            F2;
         end if;
      end;
      E135 := E135 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "system__pool_global__finalize_spec");
      begin
         if E135 = 0 then
            F3;
         end if;
      end;
      E122 := E122 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__finalization_masters__finalize_spec");
      begin
         if E122 = 0 then
            F4;
         end if;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure zlib_adafinal is

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      finalize_library;
   end zlib_adafinal;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure zlib_adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;

      zlib_adamain'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      if E021 = 0 then
         Ada.Exceptions'Elab_Spec;
      end if;
      if E017 = 0 then
         System.Soft_Links'Elab_Spec;
      end if;
      if E015 = 0 then
         System.Exception_Table'Elab_Body;
      end if;
      E015 := E015 + 1;
      if E040 = 0 then
         Ada.Containers'Elab_Spec;
      end if;
      E040 := E040 + 1;
      if E069 = 0 then
         Ada.Io_Exceptions'Elab_Spec;
      end if;
      E069 := E069 + 1;
      if E030 = 0 then
         Ada.Numerics'Elab_Spec;
      end if;
      E030 := E030 + 1;
      if E012 = 0 then
         Ada.Strings'Elab_Spec;
      end if;
      E012 := E012 + 1;
      if E058 = 0 then
         Ada.Strings.Maps'Elab_Spec;
      end if;
      E058 := E058 + 1;
      if E061 = 0 then
         Ada.Strings.Maps.Constants'Elab_Spec;
      end if;
      E061 := E061 + 1;
      if E045 = 0 then
         Interfaces.C'Elab_Spec;
      end if;
      E045 := E045 + 1;
      if E024 = 0 then
         System.Exceptions'Elab_Spec;
      end if;
      E024 := E024 + 1;
      if E085 = 0 then
         System.Object_Reader'Elab_Spec;
      end if;
      E085 := E085 + 1;
      if E052 = 0 then
         System.Dwarf_Lines'Elab_Spec;
      end if;
      E052 := E052 + 1;
      if E074 = 0 then
         System.Os_Lib'Elab_Body;
      end if;
      E074 := E074 + 1;
      if E104 = 0 then
         System.Soft_Links.Initialize'Elab_Body;
      end if;
      E104 := E104 + 1;
      E017 := E017 + 1;
      if E039 = 0 then
         System.Traceback.Symbolic'Elab_Body;
      end if;
      E039 := E039 + 1;
      E021 := E021 + 1;
      if E108 = 0 then
         Ada.Strings.Utf_Encoding'Elab_Spec;
      end if;
      E108 := E108 + 1;
      if E116 = 0 then
         Ada.Tags'Elab_Spec;
      end if;
      if E116 = 0 then
         Ada.Tags'Elab_Body;
      end if;
      E116 := E116 + 1;
      if E011 = 0 then
         Ada.Strings.Text_Buffers'Elab_Spec;
      end if;
      E011 := E011 + 1;
      if E139 = 0 then
         Interfaces.C.Strings'Elab_Spec;
      end if;
      E139 := E139 + 1;
      if E125 = 0 then
         Ada.Streams'Elab_Spec;
      end if;
      E125 := E125 + 1;
      if E131 = 0 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E131 := E131 + 1;
      if E123 = 0 then
         Ada.Finalization'Elab_Spec;
      end if;
      E123 := E123 + 1;
      if E133 = 0 then
         System.Storage_Pools'Elab_Spec;
      end if;
      E133 := E133 + 1;
      if E122 = 0 then
         System.Finalization_Masters'Elab_Spec;
      end if;
      if E122 = 0 then
         System.Finalization_Masters'Elab_Body;
      end if;
      E122 := E122 + 1;
      if E135 = 0 then
         System.Pool_Global'Elab_Spec;
      end if;
      E135 := E135 + 1;
      if E006 = 0 then
         Zlib'Elab_Spec;
      end if;
      if E004 = 0 then
         Zlib.Thin'Elab_Body;
      end if;
      E004 := E004 + 1;
      if E006 = 0 then
         Zlib'Elab_Body;
      end if;
      E006 := E006 + 1;
      if E002 = 0 then
         Zlib.Streams'Elab_Spec;
      end if;
      if E002 = 0 then
         Zlib.Streams'Elab_Body;
      end if;
      E002 := E002 + 1;
   end zlib_adainit;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/zlib-ada-git-ca39312ba02e84eb15799300ef83607a83402868/zlib-thin.o
   --   /builddir/build/BUILD/zlib-ada-git-ca39312ba02e84eb15799300ef83607a83402868/zlib.o
   --   /builddir/build/BUILD/zlib-ada-git-ca39312ba02e84eb15799300ef83607a83402868/zlib-streams.o
   --   -L/builddir/build/BUILD/zlib-ada-git-ca39312ba02e84eb15799300ef83607a83402868/
   --   -L/usr/lib/gcc/ppc64le-redhat-linux/14/adalib/
   --   -static
   --   -lgnat
   --   -ldl
--  END Object file/option list   

end zlib_adamain;
